type

  accessflags    = longint;
  combinedboards = array [1..125] of byte;
  time           = array [1..3] of byte;
  date           = array [1..3] of byte;
  TimeFrameRec   = Array [1..7, 1..6] of Byte;

  accessrecord = record
    minLevel:      Word;
    maxLevel:      Word;
    Flags:         AccessFlags;
    FlagsNot:      AccessFlags;
    minAge:        Byte;
    maxAge:        Byte;
    Sex:           Byte;
    minTimeLeft:   Word;
    minTimeOnline: Word;
    TimeFrame:     TimeFrameRec;
    Terminals:     Byte;
    minSpeed:      LongInt;
    maxSpeed:      LongInt;
    extra:         array [1..50] of byte;
  end;

  userspbrecord = record
    name:              string [35];
    country:           string [25];
    state:             string [25];
    faxphone:          string [15];
    password:          string [15];
    language:          string [8];
    lastpwdchange:     date;
    lastnewfilescheck: date;
    loglevel:          word;
    tbtimebalance:     word;
    tbkbbalance:       word;
    tbtimewithdrawn:   word;
    tbkbwithdrawn:     word;
    tbtimedeposited:   word;
    tbkbdeposited:     word;
    tbtimeloaned:      word;
    tbkbloaned:        word;
    tbtimepayback:     date;
    tbkbpayback:       date;
    tblastused:        date;
    explevel:          word;
    expflagson:        accessflags;
    expflagsoff:       accessflags;
    uflags:            longint;
    mailcheckboards:   combinedboards;
    totaltimeused:     longint;
    qwkmaxmsgsperarea: word;
    QWKmaxMsgs:        Word;
    QWKArchiver:       Byte;
    RipFont:           Byte;
    CheckMail:         Byte;
    CheckNewFiles:     Byte;
    Extra:             Array [1..398] of Byte;
  end;

const

  RA_UFLAG_NOIBM      =   1;
  RA_UFLAG_NOTOPS     =   2;
  RA_UFLAG_AVTPLUS    =   4;
  RA_UFLAG_ATTEN      =   8;
  RA_UFLAG_NORIP      =  16;
  RA_UFLAG_MULTILOGIN =  32;
  RA_UFLAG_FREECHAT   =  64;
  RA_UFLAG_LOCALONLY  = 128;

type

  FileCfgPro = record (* FILECFG.PRO *)
    Name:       String [79];
    listPath:   String [79];
    FilePath:   String [79];
    Level:      Word;
    Flags:      LongInt;
    Typ:        Byte;
    MaxFiles:   Word;
    MaxKB:      Word;
    NotOps:     Byte;
    Free:       Byte;
    Groups:     Array [1..4] of Byte;
    AllGroups:  Byte;
    MinAge:     Byte;
    FlagsNot:   LongInt;
    DateFormat: Byte;
    Extra:      Array [1..2] of Byte;
  end;

  MessagesPB = Record (* MESSAGES.PB *)
    AreaNum:       Word;
    HudsonBase:    Word;
    Name:          String [80];
    MsgType:       Byte;
    MsgKind:       Byte;
    MsgBaseType:   Byte;
    Path:          String [80];
    Flags:         Byte;
    ReadLevel:     Word;
    ReadFlags:     AccessFlags;
    ReadFlagsNot:  AccessFlags;
    WriteLevel:    Word;
    WriteFlags:    AccessFlags;
    WriteFlagsNot: AccessFlags;
    SysopLevel:    Word;
    SysopFlags:    AccessFlags;
    SysopFlagsNot: AccessFlags;
    Origin:        String [61];
    Aka:           Word;
    RcvKillDays:   Word;
    MsgKillDays:   Word;
    MaxMsgs:       Word;
    Sysop:         String [35];
    ReplyBoard:    Word;
    EchoTag:       String [60];
    QWKTag:        String [12];
    Groups:        Array [1..4] of Byte;
    AllGroups:     Byte;
    MinAge:        Byte;
    Extra:         Array [1..112] of Byte;
  end;

const

  MSGTYPE_BOTH    = 0;
  MSGTYPE_PVT     = 1;
  MSGTYPE_PUBLIC  = 2;
  MSGTYPE_TOALL   = 3;

  MSGKIND_LOCAL   = 0;
  MSGKIND_NET     = 1;
  MSGKIND_ECHO    = 2;
  MSGKIND_PVTECHO = 3;

  MSGBASE_HUDSON  = 0;
  MSGBASE_SQUISH  = 1;
  MSGBASE_SDM     = 2;
  MSGBASE_JAM     = 3;

type CONFIG_PRO = Record
       ShellMsg: String [80];
       SysopName: String [35];
       TxtPath: String[60];
       MnuPath: String[60];
       MsgPath: String[60];
       UploadPath: String[60];
       EditorName: String[60];
       NewUserLevel: Word;
       NewUserLogLevel: Byte;
       NewUserFlags: AccessFlags;
       max_passinput: Byte;
       min_passlength: Byte;
       inactivity_time: Byte;
       max_sysop_pages: Byte;
       pagebell_length: Byte;
       mailcheck: Byte;
       europe: Byte;
       numnodes: Byte;
       allowansi: Boolean;
       allowavatar: Boolean;
       discrete: Byte;
       askphone: Byte;
       allowoneword: Byte;
       crashlevel: Word;
       crashflags: AccessFlags;
       attachlevel: Word;
       attachflags: AccessFlags;
       allowmsgupload: Byte;
       allowstacking: Byte;
       page_start: Time;
       page_end: Time;
       handshaking: Byte;
       allowalias: Byte;
       loglocal: Byte;
       doswap: Byte;
       originline: String [60];
       nodelistdir: String [60];
       sysopkeys: Array [1..10] of String [59];
       dl_start: Time;
       dl_end: Time;
       uploadspace: Byte;
       pvtuploadpath: String [60];
       quotestring: String [5];
       fastmode: Boolean;
       extra_bool_1: Boolean;
       killsent: Boolean;
       multiline: Boolean;
       egamode: Boolean;
       showuserinfo: Boolean;
       pexpath: String [60];
       allowquicklogin: Boolean;
       suspendmsgtime: Boolean;
       securityboard: Byte;
       pwdmessages: Boolean;
       extra_bool_2: Boolean;
       bbsname: String [35];
       pwdchar: Char;
       tb_maxtimedeposit: Byte;
       tb_maxkbdeposit: Byte;
       tb_maxtimewithdrawal: Byte;
       tb_maxkbwithdrawal: Byte;
       usage_days: Byte;
       systempwd: String [15];
       usesystempwd: Boolean;
       askbirthdate: Boolean;
       binlogdays: Byte;
       binloglocal: Boolean;
       pageArea: Byte;
       indexfiles: Boolean;
       checkdupes: Boolean;
       killdupes: Boolean;
       ignore_ext: Boolean;
       RIPpath: String [60];
       iconspath: String [60];
       location: String [35];
       phone: String [25];
       QWKid: String [8];
       IObuffersize: Word;
       pagingHours: TimeFrameRec;
       defaultLanguage: String[8];
       addUploaderName: Boolean;
       downloadHours: TimeFrameRec;
       askdataphone: Boolean;
       askfaxphone: Boolean;
       askaddress: Boolean;
       asksex: Boolean;
       askdateformat: Boolean;
       askstate: Boolean;
       askcountry: Boolean;
       fuzzyRate: Byte;
       hidePassword: Boolean;
       valConfirm: Boolean;
       extra_char_1: Array [1..17] of Byte;
       extChat: String [80];
       virScanCommand: String [60];
       virScanType: Byte;
       virScanSemaphore: String [12];
       listColorTag: Byte;
       listColorFileName: Byte;
       listColorSize: Byte;
       listColorDate: Byte;
       listColorCounter: Byte;
       listColorDesc: Byte;
       listColorSeperator: Byte;
       listColorMissing: Byte;
       hideFileCounter: Boolean;
       disableRIP: Boolean;
       extra_char_2: Array [1..81] of Byte;
       virScanFailedAction: Byte;
       virScanFailedArea: Word;
       promptColor: Byte;
       internalfsed: Boolean;
       extra: Array [1..3] of Byte;
    end;
